/*
** QGL_WIN.C
**
** This file implements the operating system binding of GL to QGL function
** pointers.  When doing a port of Quake2 you must implement the following
** two functions:
**
** QGL_Init() - loads libraries, assigns function pointers, etc.
** QGL_Shutdown() - unloads libraries, NULLs function pointers
*/
#define QGL
#include "../ref_gl/gl_local.h"

//void ( APIENTRY * qglAccum )(GLenum op, GLfloat value);
void ( APIENTRY * qglAlphaFunc )(GLenum func, GLclampf ref);
//GLboolean ( APIENTRY * qglAreTexturesResident )(GLsizei n, const GLuint *textures, GLboolean *residences);
void ( APIENTRY * qglArrayElement )(GLint i);
void ( APIENTRY * qglBegin )(GLenum mode);
void ( APIENTRY * qglBindTexture )(GLenum target, GLuint texture);
//void ( APIENTRY * qglBitmap )(GLsizei width, GLsizei height, GLfloat xorig, GLfloat yorig, GLfloat xmove, GLfloat ymove, const GLubyte *bitmap);
void ( APIENTRY * qglBlendFunc )(GLenum sfactor, GLenum dfactor);
void ( APIENTRY * qglCallList )(GLuint list);
void ( APIENTRY * qglCallLists )(GLsizei n, GLenum type, const GLvoid *lists);
void ( APIENTRY * qglClear )(GLbitfield mask);
//void ( APIENTRY * qglClearAccum )(GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);
void ( APIENTRY * qglClearColor )(GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha);
void ( APIENTRY * qglClearDepth )(GLclampd depth);
//void ( APIENTRY * qglClearIndex )(GLfloat c);
void ( APIENTRY * qglClearStencil )(GLint s);
void ( APIENTRY * qglClipPlane )(GLenum plane, const GLdouble *equation);
void ( APIENTRY * qglColor3b )(GLbyte red, GLbyte green, GLbyte blue);
void ( APIENTRY * qglColor3bv )(const GLbyte *v);
void ( APIENTRY * qglColor3d )(GLdouble red, GLdouble green, GLdouble blue);
void ( APIENTRY * qglColor3dv )(const GLdouble *v);
void ( APIENTRY * qglColor3f )(GLfloat red, GLfloat green, GLfloat blue);
void ( APIENTRY * qglColor3fv )(const GLfloat *v);
void ( APIENTRY * qglColor3i )(GLint red, GLint green, GLint blue);
void ( APIENTRY * qglColor3iv )(const GLint *v);
void ( APIENTRY * qglColor3s )(GLshort red, GLshort green, GLshort blue);
void ( APIENTRY * qglColor3sv )(const GLshort *v);
void ( APIENTRY * qglColor3ub )(GLubyte red, GLubyte green, GLubyte blue);
void ( APIENTRY * qglColor3ubv )(const GLubyte *v);
void ( APIENTRY * qglColor3ui )(GLuint red, GLuint green, GLuint blue);
void ( APIENTRY * qglColor3uiv )(const GLuint *v);
void ( APIENTRY * qglColor3us )(GLushort red, GLushort green, GLushort blue);
void ( APIENTRY * qglColor3usv )(const GLushort *v);
void ( APIENTRY * qglColor4b )(GLbyte red, GLbyte green, GLbyte blue, GLbyte alpha);
void ( APIENTRY * qglColor4bv )(const GLbyte *v);
void ( APIENTRY * qglColor4d )(GLdouble red, GLdouble green, GLdouble blue, GLdouble alpha);
void ( APIENTRY * qglColor4dv )(const GLdouble *v);
void ( APIENTRY * qglColor4f )(GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha);
void ( APIENTRY * qglColor4fv )(const GLfloat *v);
void ( APIENTRY * qglColor4i )(GLint red, GLint green, GLint blue, GLint alpha);
void ( APIENTRY * qglColor4iv )(const GLint *v);
void ( APIENTRY * qglColor4s )(GLshort red, GLshort green, GLshort blue, GLshort alpha);
void ( APIENTRY * qglColor4sv )(const GLshort *v);
void ( APIENTRY * qglColor4ub )(GLubyte red, GLubyte green, GLubyte blue, GLubyte alpha);
void ( APIENTRY * qglColor4ubv )(const GLubyte *v);
void ( APIENTRY * qglColor4ui )(GLuint red, GLuint green, GLuint blue, GLuint alpha);
void ( APIENTRY * qglColor4uiv )(const GLuint *v);
void ( APIENTRY * qglColor4us )(GLushort red, GLushort green, GLushort blue, GLushort alpha);
void ( APIENTRY * qglColor4usv )(const GLushort *v);
void ( APIENTRY * qglColorMask )(GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha);
void ( APIENTRY * qglColorMaterial )(GLenum face, GLenum mode);
void ( APIENTRY * qglColorPointer )(GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
//void ( APIENTRY * qglCopyPixels )(GLint x, GLint y, GLsizei width, GLsizei height, GLenum type);
//void ( APIENTRY * qglCopyTexImage1D )(GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLint border);
//void ( APIENTRY * qglCopyTexImage2D )(GLenum target, GLint level, GLenum internalFormat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border);
//void ( APIENTRY * qglCopyTexSubImage1D )(GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width);
//void ( APIENTRY * qglCopyTexSubImage2D )(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height);
void ( APIENTRY * qglCullFace )(GLenum mode);
void ( APIENTRY * qglDeleteLists )(GLuint list, GLsizei range);
void ( APIENTRY * qglDeleteTextures )(GLsizei n, const GLuint *textures);
void ( APIENTRY * qglDepthFunc )(GLenum func);
void ( APIENTRY * qglDepthMask )(GLboolean flag);
void ( APIENTRY * qglDepthRange )(GLclampd zNear, GLclampd zFar);
void ( APIENTRY * qglDisable )(GLenum cap);
void ( APIENTRY * qglDisableClientState )(GLenum array);
void ( APIENTRY * qglDrawArrays )(GLenum mode, GLint first, GLsizei count);
void ( APIENTRY * qglDrawBuffer )(GLenum mode);
void ( APIENTRY * qglDrawElements )(GLenum mode, GLsizei count, GLenum type, const GLvoid *indices);
//void ( APIENTRY * qglDrawPixels )(GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels);
//void ( APIENTRY * qglEdgeFlag )(GLboolean flag);
//void ( APIENTRY * qglEdgeFlagPointer )(GLsizei stride, const GLvoid *pointer);
//void ( APIENTRY * qglEdgeFlagv )(const GLboolean *flag);
void ( APIENTRY * qglEnable )(GLenum cap);
void ( APIENTRY * qglEnableClientState )(GLenum array);
void ( APIENTRY * qglEnd )(void);
void ( APIENTRY * qglEndList )(void);
//void ( APIENTRY * qglEvalCoord1d )(GLdouble u);
//void ( APIENTRY * qglEvalCoord1dv )(const GLdouble *u);
//void ( APIENTRY * qglEvalCoord1f )(GLfloat u);
//void ( APIENTRY * qglEvalCoord1fv )(const GLfloat *u);
//void ( APIENTRY * qglEvalCoord2d )(GLdouble u, GLdouble v);
//void ( APIENTRY * qglEvalCoord2dv )(const GLdouble *u);
//void ( APIENTRY * qglEvalCoord2f )(GLfloat u, GLfloat v);
//void ( APIENTRY * qglEvalCoord2fv )(const GLfloat *u);
//void ( APIENTRY * qglEvalMesh1 )(GLenum mode, GLint i1, GLint i2);
//void ( APIENTRY * qglEvalMesh2 )(GLenum mode, GLint i1, GLint i2, GLint j1, GLint j2);
//void ( APIENTRY * qglEvalPoint1 )(GLint i);
//void ( APIENTRY * qglEvalPoint2 )(GLint i, GLint j);
//void ( APIENTRY * qglFeedbackBuffer )(GLsizei size, GLenum type, GLfloat *buffer);
void ( APIENTRY * qglFinish )(void);
void ( APIENTRY * qglFlush )(void);
void ( APIENTRY * qglFogf )(GLenum pname, GLfloat param);
void ( APIENTRY * qglFogfv )(GLenum pname, const GLfloat *params);
void ( APIENTRY * qglFogi )(GLenum pname, GLint param);
void ( APIENTRY * qglFogiv )(GLenum pname, const GLint *params);
void ( APIENTRY * qglFrontFace )(GLenum mode);
void ( APIENTRY * qglFrustum )(GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
//GLuint ( APIENTRY * qglGenLists )(GLsizei range);
//void ( APIENTRY * qglGenTextures )(GLsizei n, GLuint *textures);
//void ( APIENTRY * qglGetBooleanv )(GLenum pname, GLboolean *params);
//void ( APIENTRY * qglGetClipPlane )(GLenum plane, GLdouble *equation);
//void ( APIENTRY * qglGetDoublev )(GLenum pname, GLdouble *params);
GLenum ( APIENTRY * qglGetError )(void);
void ( APIENTRY * qglGetFloatv )(GLenum pname, GLfloat *params);
void ( APIENTRY * qglGetIntegerv )(GLenum pname, GLint *params);
//void ( APIENTRY * qglGetLightfv )(GLenum light, GLenum pname, GLfloat *params);
//void ( APIENTRY * qglGetLightiv )(GLenum light, GLenum pname, GLint *params);
//void ( APIENTRY * qglGetMapdv )(GLenum target, GLenum query, GLdouble *v);
//void ( APIENTRY * qglGetMapfv )(GLenum target, GLenum query, GLfloat *v);
//void ( APIENTRY * qglGetMapiv )(GLenum target, GLenum query, GLint *v);
//void ( APIENTRY * qglGetMaterialfv )(GLenum face, GLenum pname, GLfloat *params);
//void ( APIENTRY * qglGetMaterialiv )(GLenum face, GLenum pname, GLint *params);
//void ( APIENTRY * qglGetPixelMapfv )(GLenum map, GLfloat *values);
//void ( APIENTRY * qglGetPixelMapuiv )(GLenum map, GLuint *values);
//void ( APIENTRY * qglGetPixelMapusv )(GLenum map, GLushort *values);
void ( APIENTRY * qglGetPointerv )(GLenum pname, GLvoid* *params);
void ( APIENTRY * qglGetPolygonStipple )(GLubyte *mask);
const GLubyte * ( APIENTRY * qglGetString )(GLenum name);
void ( APIENTRY * qglGetTexEnvfv )(GLenum target, GLenum pname, GLfloat *params);
void ( APIENTRY * qglGetTexEnviv )(GLenum target, GLenum pname, GLint *params);
void ( APIENTRY * qglGetTexGendv )(GLenum coord, GLenum pname, GLdouble *params);
void ( APIENTRY * qglGetTexGenfv )(GLenum coord, GLenum pname, GLfloat *params);
void ( APIENTRY * qglGetTexGeniv )(GLenum coord, GLenum pname, GLint *params);
void ( APIENTRY * qglGetTexImage )(GLenum target, GLint level, GLenum format, GLenum type, GLvoid *pixels);
void ( APIENTRY * qglGetTexLevelParameterfv )(GLenum target, GLint level, GLenum pname, GLfloat *params);
void ( APIENTRY * qglGetTexLevelParameteriv )(GLenum target, GLint level, GLenum pname, GLint *params);
void ( APIENTRY * qglGetTexParameterfv )(GLenum target, GLenum pname, GLfloat *params);
void ( APIENTRY * qglGetTexParameteriv )(GLenum target, GLenum pname, GLint *params);
void ( APIENTRY * qglHint )(GLenum target, GLenum mode);
void ( APIENTRY * qglIndexMask )(GLuint mask);
void ( APIENTRY * qglIndexPointer )(GLenum type, GLsizei stride, const GLvoid *pointer);
void ( APIENTRY * qglIndexd )(GLdouble c);
void ( APIENTRY * qglIndexdv )(const GLdouble *c);
void ( APIENTRY * qglIndexf )(GLfloat c);
void ( APIENTRY * qglIndexfv )(const GLfloat *c);
void ( APIENTRY * qglIndexi )(GLint c);
void ( APIENTRY * qglIndexiv )(const GLint *c);
void ( APIENTRY * qglIndexs )(GLshort c);
void ( APIENTRY * qglIndexsv )(const GLshort *c);
void ( APIENTRY * qglIndexub )(GLubyte c);
void ( APIENTRY * qglIndexubv )(const GLubyte *c);
void ( APIENTRY * qglInitNames )(void);
void ( APIENTRY * qglInterleavedArrays )(GLenum format, GLsizei stride, const GLvoid *pointer);
GLboolean ( APIENTRY * qglIsEnabled )(GLenum cap);
GLboolean ( APIENTRY * qglIsList )(GLuint list);
GLboolean ( APIENTRY * qglIsTexture )(GLuint texture);
void ( APIENTRY * qglLightModelf )(GLenum pname, GLfloat param);
void ( APIENTRY * qglLightModelfv )(GLenum pname, const GLfloat *params);
void ( APIENTRY * qglLightModeli )(GLenum pname, GLint param);
void ( APIENTRY * qglLightModeliv )(GLenum pname, const GLint *params);
void ( APIENTRY * qglLightf )(GLenum light, GLenum pname, GLfloat param);
void ( APIENTRY * qglLightfv )(GLenum light, GLenum pname, const GLfloat *params);
void ( APIENTRY * qglLighti )(GLenum light, GLenum pname, GLint param);
void ( APIENTRY * qglLightiv )(GLenum light, GLenum pname, const GLint *params);
void ( APIENTRY * qglLineStipple )(GLint factor, GLushort pattern);
void ( APIENTRY * qglLineWidth )(GLfloat width);
void ( APIENTRY * qglListBase )(GLuint base);
void ( APIENTRY * qglLoadIdentity )(void);
void ( APIENTRY * qglLoadMatrixd )(const GLdouble *m);
void ( APIENTRY * qglLoadMatrixf )(const GLfloat *m);
void ( APIENTRY * qglLoadName )(GLuint name);
void ( APIENTRY * qglLogicOp )(GLenum opcode);
void ( APIENTRY * qglMap1d )(GLenum target, GLdouble u1, GLdouble u2, GLint stride, GLint order, const GLdouble *points);
void ( APIENTRY * qglMap1f )(GLenum target, GLfloat u1, GLfloat u2, GLint stride, GLint order, const GLfloat *points);
void ( APIENTRY * qglMap2d )(GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, const GLdouble *points);
void ( APIENTRY * qglMap2f )(GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, const GLfloat *points);
void ( APIENTRY * qglMapGrid1d )(GLint un, GLdouble u1, GLdouble u2);
void ( APIENTRY * qglMapGrid1f )(GLint un, GLfloat u1, GLfloat u2);
void ( APIENTRY * qglMapGrid2d )(GLint un, GLdouble u1, GLdouble u2, GLint vn, GLdouble v1, GLdouble v2);
void ( APIENTRY * qglMapGrid2f )(GLint un, GLfloat u1, GLfloat u2, GLint vn, GLfloat v1, GLfloat v2);
void ( APIENTRY * qglMaterialf )(GLenum face, GLenum pname, GLfloat param);
void ( APIENTRY * qglMaterialfv )(GLenum face, GLenum pname, const GLfloat *params);
void ( APIENTRY * qglMateriali )(GLenum face, GLenum pname, GLint param);
void ( APIENTRY * qglMaterialiv )(GLenum face, GLenum pname, const GLint *params);
void ( APIENTRY * qglMatrixMode )(GLenum mode);
void ( APIENTRY * qglMultMatrixd )(const GLdouble *m);
void ( APIENTRY * qglMultMatrixf )(const GLfloat *m);
void ( APIENTRY * qglNewList )(GLuint list, GLenum mode);
void ( APIENTRY * qglNormal3b )(GLbyte nx, GLbyte ny, GLbyte nz);
void ( APIENTRY * qglNormal3bv )(const GLbyte *v);
void ( APIENTRY * qglNormal3d )(GLdouble nx, GLdouble ny, GLdouble nz);
void ( APIENTRY * qglNormal3dv )(const GLdouble *v);
void ( APIENTRY * qglNormal3f )(GLfloat nx, GLfloat ny, GLfloat nz);
void ( APIENTRY * qglNormal3fv )(const GLfloat *v);
void ( APIENTRY * qglNormal3i )(GLint nx, GLint ny, GLint nz);
void ( APIENTRY * qglNormal3iv )(const GLint *v);
void ( APIENTRY * qglNormal3s )(GLshort nx, GLshort ny, GLshort nz);
void ( APIENTRY * qglNormal3sv )(const GLshort *v);
void ( APIENTRY * qglNormalPointer )(GLenum type, GLsizei stride, const GLvoid *pointer);
void ( APIENTRY * qglOrtho )(GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar);
//void ( APIENTRY * qglPassThrough )(GLfloat token);
//void ( APIENTRY * qglPixelMapfv )(GLenum map, GLsizei mapsize, const GLfloat *values);
//void ( APIENTRY * qglPixelMapuiv )(GLenum map, GLsizei mapsize, const GLuint *values);
//void ( APIENTRY * qglPixelMapusv )(GLenum map, GLsizei mapsize, const GLushort *values);
void ( APIENTRY * qglPixelStoref )(GLenum pname, GLfloat param);
void ( APIENTRY * qglPixelStorei )(GLenum pname, GLint param);
//void ( APIENTRY * qglPixelTransferf )(GLenum pname, GLfloat param);
//void ( APIENTRY * qglPixelTransferi )(GLenum pname, GLint param);
//void ( APIENTRY * qglPixelZoom )(GLfloat xfactor, GLfloat yfactor);
void ( APIENTRY * qglPointSize )(GLfloat size);
void ( APIENTRY * qglPolygonMode )(GLenum face, GLenum mode);
void ( APIENTRY * qglPolygonOffset )(GLfloat factor, GLfloat units);
//void ( APIENTRY * qglPolygonStipple )(const GLubyte *mask);
void ( APIENTRY * qglPopAttrib )(void);
void ( APIENTRY * qglPopClientAttrib )(void);
void ( APIENTRY * qglPopMatrix )(void);
void ( APIENTRY * qglPopName )(void);
void ( APIENTRY * qglPrioritizeTextures )(GLsizei n, const GLuint *textures, const GLclampf *priorities);
void ( APIENTRY * qglPushAttrib )(GLbitfield mask);
void ( APIENTRY * qglPushClientAttrib )(GLbitfield mask);
void ( APIENTRY * qglPushMatrix )(void);
void ( APIENTRY * qglPushName )(GLuint name);
void ( APIENTRY * qglRasterPos2d )(GLdouble x, GLdouble y);
void ( APIENTRY * qglRasterPos2dv )(const GLdouble *v);
void ( APIENTRY * qglRasterPos2f )(GLfloat x, GLfloat y);
void ( APIENTRY * qglRasterPos2fv )(const GLfloat *v);
void ( APIENTRY * qglRasterPos2i )(GLint x, GLint y);
void ( APIENTRY * qglRasterPos2iv )(const GLint *v);
void ( APIENTRY * qglRasterPos2s )(GLshort x, GLshort y);
void ( APIENTRY * qglRasterPos2sv )(const GLshort *v);
void ( APIENTRY * qglRasterPos3d )(GLdouble x, GLdouble y, GLdouble z);
void ( APIENTRY * qglRasterPos3dv )(const GLdouble *v);
void ( APIENTRY * qglRasterPos3f )(GLfloat x, GLfloat y, GLfloat z);
void ( APIENTRY * qglRasterPos3fv )(const GLfloat *v);
void ( APIENTRY * qglRasterPos3i )(GLint x, GLint y, GLint z);
void ( APIENTRY * qglRasterPos3iv )(const GLint *v);
void ( APIENTRY * qglRasterPos3s )(GLshort x, GLshort y, GLshort z);
void ( APIENTRY * qglRasterPos3sv )(const GLshort *v);
void ( APIENTRY * qglRasterPos4d )(GLdouble x, GLdouble y, GLdouble z, GLdouble w);
void ( APIENTRY * qglRasterPos4dv )(const GLdouble *v);
void ( APIENTRY * qglRasterPos4f )(GLfloat x, GLfloat y, GLfloat z, GLfloat w);
void ( APIENTRY * qglRasterPos4fv )(const GLfloat *v);
void ( APIENTRY * qglRasterPos4i )(GLint x, GLint y, GLint z, GLint w);
void ( APIENTRY * qglRasterPos4iv )(const GLint *v);
void ( APIENTRY * qglRasterPos4s )(GLshort x, GLshort y, GLshort z, GLshort w);
void ( APIENTRY * qglRasterPos4sv )(const GLshort *v);
void ( APIENTRY * qglReadBuffer )(GLenum mode);
void ( APIENTRY * qglReadPixels )(GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *pixels);
//void ( APIENTRY * qglRectd )(GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2);
//void ( APIENTRY * qglRectdv )(const GLdouble *v1, const GLdouble *v2);
//void ( APIENTRY * qglRectf )(GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2);
//void ( APIENTRY * qglRectfv )(const GLfloat *v1, const GLfloat *v2);
//void ( APIENTRY * qglRecti )(GLint x1, GLint y1, GLint x2, GLint y2);
//void ( APIENTRY * qglRectiv )(const GLint *v1, const GLint *v2);
//void ( APIENTRY * qglRects )(GLshort x1, GLshort y1, GLshort x2, GLshort y2);
//void ( APIENTRY * qglRectsv )(const GLshort *v1, const GLshort *v2);
//GLint ( APIENTRY * qglRenderMode )(GLenum mode);
void ( APIENTRY * qglRotated )(GLdouble angle, GLdouble x, GLdouble y, GLdouble z);
void ( APIENTRY * qglRotatef )(GLfloat angle, GLfloat x, GLfloat y, GLfloat z);
void ( APIENTRY * qglScaled )(GLdouble x, GLdouble y, GLdouble z);
void ( APIENTRY * qglScalef )(GLfloat x, GLfloat y, GLfloat z);
void ( APIENTRY * qglScissor )(GLint x, GLint y, GLsizei width, GLsizei height);
//void ( APIENTRY * qglSelectBuffer )(GLsizei size, GLuint *buffer);
void ( APIENTRY * qglShadeModel )(GLenum mode);
void ( APIENTRY * qglStencilFunc )(GLenum func, GLint ref, GLuint mask);
void ( APIENTRY * qglStencilMask )(GLuint mask);
void ( APIENTRY * qglStencilOp )(GLenum fail, GLenum zfail, GLenum zpass);
void ( APIENTRY * qglTexCoord1d )(GLdouble s);
void ( APIENTRY * qglTexCoord1dv )(const GLdouble *v);
void ( APIENTRY * qglTexCoord1f )(GLfloat s);
void ( APIENTRY * qglTexCoord1fv )(const GLfloat *v);
void ( APIENTRY * qglTexCoord1i )(GLint s);
void ( APIENTRY * qglTexCoord1iv )(const GLint *v);
void ( APIENTRY * qglTexCoord1s )(GLshort s);
void ( APIENTRY * qglTexCoord1sv )(const GLshort *v);
void ( APIENTRY * qglTexCoord2d )(GLdouble s, GLdouble t);
void ( APIENTRY * qglTexCoord2dv )(const GLdouble *v);
void ( APIENTRY * qglTexCoord2f )(GLfloat s, GLfloat t);
void ( APIENTRY * qglTexCoord2fv )(const GLfloat *v);
void ( APIENTRY * qglTexCoord2i )(GLint s, GLint t);
void ( APIENTRY * qglTexCoord2iv )(const GLint *v);
void ( APIENTRY * qglTexCoord2s )(GLshort s, GLshort t);
void ( APIENTRY * qglTexCoord2sv )(const GLshort *v);
void ( APIENTRY * qglTexCoord3d )(GLdouble s, GLdouble t, GLdouble r);
void ( APIENTRY * qglTexCoord3dv )(const GLdouble *v);
void ( APIENTRY * qglTexCoord3f )(GLfloat s, GLfloat t, GLfloat r);
void ( APIENTRY * qglTexCoord3fv )(const GLfloat *v);
void ( APIENTRY * qglTexCoord3i )(GLint s, GLint t, GLint r);
void ( APIENTRY * qglTexCoord3iv )(const GLint *v);
void ( APIENTRY * qglTexCoord3s )(GLshort s, GLshort t, GLshort r);
void ( APIENTRY * qglTexCoord3sv )(const GLshort *v);
void ( APIENTRY * qglTexCoord4d )(GLdouble s, GLdouble t, GLdouble r, GLdouble q);
void ( APIENTRY * qglTexCoord4dv )(const GLdouble *v);
void ( APIENTRY * qglTexCoord4f )(GLfloat s, GLfloat t, GLfloat r, GLfloat q);
void ( APIENTRY * qglTexCoord4fv )(const GLfloat *v);
void ( APIENTRY * qglTexCoord4i )(GLint s, GLint t, GLint r, GLint q);
void ( APIENTRY * qglTexCoord4iv )(const GLint *v);
void ( APIENTRY * qglTexCoord4s )(GLshort s, GLshort t, GLshort r, GLshort q);
void ( APIENTRY * qglTexCoord4sv )(const GLshort *v);
void ( APIENTRY * qglTexCoordPointer )(GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
void ( APIENTRY * qglTexEnvf )(GLenum target, GLenum pname, GLfloat param);
void ( APIENTRY * qglTexEnvfv )(GLenum target, GLenum pname, const GLfloat *params);
void ( APIENTRY * qglTexEnvi )(GLenum target, GLenum pname, GLint param);
//void ( APIENTRY * qglTexEnviv )(GLenum target, GLenum pname, const GLint *params);
void ( APIENTRY * qglTexGend )(GLenum coord, GLenum pname, GLdouble param);
void ( APIENTRY * qglTexGendv )(GLenum coord, GLenum pname, const GLdouble *params);
void ( APIENTRY * qglTexGenf )(GLenum coord, GLenum pname, GLfloat param);
void ( APIENTRY * qglTexGenfv )(GLenum coord, GLenum pname, const GLfloat *params);
void ( APIENTRY * qglTexGeni )(GLenum coord, GLenum pname, GLint param);
void ( APIENTRY * qglTexGeniv )(GLenum coord, GLenum pname, const GLint *params);
void ( APIENTRY * qglTexImage1D )(GLenum target, GLint level, GLint internalformat, GLsizei width, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
void ( APIENTRY * qglTexImage2D )(GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels);
void ( APIENTRY * qglTexParameterf )(GLenum target, GLenum pname, GLfloat param);
void ( APIENTRY * qglTexParameterfv )(GLenum target, GLenum pname, const GLfloat *params);
void ( APIENTRY * qglTexParameteri )(GLenum target, GLenum pname, GLint param);
void ( APIENTRY * qglTexParameteriv )(GLenum target, GLenum pname, const GLint *params);
void ( APIENTRY * qglTexSubImage1D )(GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const GLvoid *pixels);
void ( APIENTRY * qglTexSubImage2D )(GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels);
void ( APIENTRY * qglTranslated )(GLdouble x, GLdouble y, GLdouble z);
void ( APIENTRY * qglTranslatef )(GLfloat x, GLfloat y, GLfloat z);
void ( APIENTRY * qglVertex2d )(GLdouble x, GLdouble y);
void ( APIENTRY * qglVertex2dv )(const GLdouble *v);
void ( APIENTRY * qglVertex2f )(GLfloat x, GLfloat y);
void ( APIENTRY * qglVertex2fv )(const GLfloat *v);
void ( APIENTRY * qglVertex2i )(GLint x, GLint y);
void ( APIENTRY * qglVertex2iv )(const GLint *v);
void ( APIENTRY * qglVertex2s )(GLshort x, GLshort y);
void ( APIENTRY * qglVertex2sv )(const GLshort *v);
void ( APIENTRY * qglVertex3d )(GLdouble x, GLdouble y, GLdouble z);
void ( APIENTRY * qglVertex3dv )(const GLdouble *v);
void ( APIENTRY * qglVertex3f )(GLfloat x, GLfloat y, GLfloat z);
void ( APIENTRY * qglVertex3fv )(const GLfloat *v);
void ( APIENTRY * qglVertex3i )(GLint x, GLint y, GLint z);
void ( APIENTRY * qglVertex3iv )(const GLint *v);
void ( APIENTRY * qglVertex3s )(GLshort x, GLshort y, GLshort z);
void ( APIENTRY * qglVertex3sv )(const GLshort *v);
void ( APIENTRY * qglVertex4d )(GLdouble x, GLdouble y, GLdouble z, GLdouble w);
void ( APIENTRY * qglVertex4dv )(const GLdouble *v);
void ( APIENTRY * qglVertex4f )(GLfloat x, GLfloat y, GLfloat z, GLfloat w);
void ( APIENTRY * qglVertex4fv )(const GLfloat *v);
void ( APIENTRY * qglVertex4i )(GLint x, GLint y, GLint z, GLint w);
void ( APIENTRY * qglVertex4iv )(const GLint *v);
void ( APIENTRY * qglVertex4s )(GLshort x, GLshort y, GLshort z, GLshort w);
void ( APIENTRY * qglVertex4sv )(const GLshort *v);
void ( APIENTRY * qglVertexPointer )(GLint size, GLenum type, GLsizei stride, const GLvoid *pointer);
void ( APIENTRY * qglViewport )(GLint x, GLint y, GLsizei width, GLsizei height);

void ( APIENTRY * qglLockArraysEXT)( GLint, GLsizei);
void ( APIENTRY * qglUnlockArraysEXT) ( void );

void ( APIENTRY * qglPointParameterfEXT)( GLenum param, GLfloat value );
void ( APIENTRY * qglPointParameterfvEXT)( GLenum param, const GLfloat *value );
void ( APIENTRY * qglColorTableEXT)( GLenum, GLenum, GLsizei, GLenum, GLenum, const GLvoid * );
void ( APIENTRY * qglSelectTextureSGIS)( GLenum );
//void ( APIENTRY * qglMTexCoord2fSGIS)( GLenum, GLfloat, GLfloat );
void ( APIENTRY * qglActiveTextureARB) ( GLenum );
void ( APIENTRY * qglClientActiveTextureARB) ( GLenum );
void ( APIENTRY * qglMultiTexCoord2f)( GLenum, GLfloat, GLfloat );

void QGL_Shutdown( void )
{
}

qboolean QGL_Init( const char *dllname )
{
	//qglAccum                  = glAccum;
	qglAlphaFunc              = glAlphaFunc;
	//qglAreTexturesResident    = glAreTexturesResident;
	qglArrayElement           = glArrayElement;
	qglBegin                  = glBegin;
	qglBindTexture            = glBindTexture;
	//qglBitmap                 = glBitmap;
	qglBlendFunc              = glBlendFunc;
	qglCallList               = glCallList;
	qglCallLists              = glCallLists;
	qglClear                  = glClear;
	//qglClearAccum             = glClearAccum;
	qglClearColor             = glClearColor;
	qglClearDepth             = glClearDepth;
	//qglClearIndex             = glClearIndex;
	qglClearStencil           = glClearStencil;
	qglClipPlane              = glClipPlane;
	qglColor3b                = glColor3b;
	qglColor3bv               = glColor3bv;
	qglColor3d                = glColor3d;
	qglColor3dv               = glColor3dv;
	qglColor3f                = glColor3f;
	qglColor3fv               = glColor3fv;
	qglColor3i                = glColor3i;
	qglColor3iv               = glColor3iv;
	qglColor3s                = glColor3s;
	qglColor3sv               = glColor3sv;
	qglColor3ub               = glColor3ub;
	qglColor3ubv              = glColor3ubv;
	qglColor3ui               = glColor3ui;
	qglColor3uiv              = glColor3uiv;
	qglColor3us               = glColor3us;
	qglColor3usv              = glColor3usv;
	qglColor4b                = glColor4b;
	qglColor4bv               = glColor4bv;
	qglColor4d                = glColor4d;
	qglColor4dv               = glColor4dv;
	qglColor4f                = glColor4f;
	qglColor4fv               = glColor4fv;
	qglColor4i                = glColor4i;
	qglColor4iv               = glColor4iv;
	qglColor4s                = glColor4s;
	qglColor4sv               = glColor4sv;
	qglColor4ub               = glColor4ub;
	qglColor4ubv              = glColor4ubv;
	qglColor4ui               = glColor4ui;
	qglColor4uiv              = glColor4uiv;
	qglColor4us               = glColor4us;
	qglColor4usv              = glColor4usv;
	qglColorMask              = glColorMask;
	qglColorMaterial          = glColorMaterial;
	qglColorPointer           = glColorPointer;
	//qglCopyPixels             = glCopyPixels;
	//qglCopyTexImage1D         = glCopyTexImage1D;
	//qglCopyTexImage2D         = glCopyTexImage2D;
	//qglCopyTexSubImage1D      = glCopyTexSubImage1D;
	//qglCopyTexSubImage2D      = glCopyTexSubImage2D;
	qglCullFace               = glCullFace;
	qglDeleteLists            = glDeleteLists;
	qglDeleteTextures         = glDeleteTextures;
	qglDepthFunc              = glDepthFunc;
	qglDepthMask              = glDepthMask;
	qglDepthRange             = glDepthRange;
	qglDisable                = glDisable;
	qglDisableClientState     = glDisableClientState;
	qglDrawArrays             = glDrawArrays;
	qglDrawBuffer             = glDrawBuffer;
	qglDrawElements           = glDrawElements;
	//qglDrawPixels             = glDrawPixels;
	//qglEdgeFlag               = glEdgeFlag;
	//qglEdgeFlagPointer        = glEdgeFlagPointer;
	//qglEdgeFlagv              = glEdgeFlagv;
	qglEnable                 = glEnable;
	qglEnableClientState      = glEnableClientState;
	qglEnd                    = glEnd;
	//qglEndList                = glEndList;
	//qglEvalCoord1d            = glEvalCoord1d;
	//qglEvalCoord1dv           = glEvalCoord1dv;
	//qglEvalCoord1f            = glEvalCoord1f;
	//qglEvalCoord1fv           = glEvalCoord1fv;
	//qglEvalCoord2d            = glEvalCoord2d;
	//qglEvalCoord2dv           = glEvalCoord2dv;
	//qglEvalCoord2f            = glEvalCoord2f;
	//qglEvalCoord2fv           = glEvalCoord2fv;
	//qglEvalMesh1              = glEvalMesh1;
	//qglEvalMesh2              = glEvalMesh2;
	//qglEvalPoint1             = glEvalPoint1;
	//qglEvalPoint2             = glEvalPoint2;
	//qglFeedbackBuffer         = glFeedbackBuffer;
	qglFinish                 = glFinish;
	qglFlush                  = glFlush;
	qglFogf                   = glFogf;
	qglFogfv                  = glFogfv;
	qglFogi                   = glFogi;
	qglFogiv                  = glFogiv;
	qglFrontFace              = glFrontFace;
	qglFrustum                = glFrustum;
	//qglGenLists               = glGenLists;
	//qglGenTextures            = glGenTextures;
	//qglGetBooleanv            = glGetBooleanv;
	//qglGetClipPlane           = glGetClipPlane;
	//qglGetDoublev             = glGetDoublev;
	qglGetError               = glGetError;
	qglGetFloatv              = glGetFloatv;
	qglGetIntegerv            = glGetIntegerv;
	//qglGetLightfv             = glGetLightfv;
	//qglGetLightiv             = glGetLightiv;
	//qglGetMapdv               = glGetMapdv;
	//qglGetMapfv               = glGetMapfv;
	//qglGetMapiv               = glGetMapiv;
	//qglGetMaterialfv          = glGetMaterialfv;
	//qglGetMaterialiv          = glGetMaterialiv;
	//qglGetPixelMapfv          = glGetPixelMapfv;
	//qglGetPixelMapuiv         = glGetPixelMapuiv;
	//qglGetPixelMapusv         = glGetPixelMapusv;
	//qglGetPointerv            = glGetPointerv;
	//qglGetPolygonStipple      = glGetPolygonStipple;
	qglGetString              = glGetString;
	//qglGetTexEnvfv            = glGetTexEnvfv;
	//qglGetTexEnviv            = glGetTexEnviv;
	//qglGetTexGendv            = glGetTexGendv;
	//qglGetTexGenfv            = glGetTexGenfv;
	//qglGetTexGeniv            = glGetTexGeniv;
	//qglGetTexImage            = glGetTexImage;
	//qglGetTexLevelParameterfv = glGetTexLevelParameterfv;
	//qglGetTexLevelParameteriv = glGetTexLevelParameteriv;
	//qglGetTexParameterfv      = glGetTexParameterfv;
	//qglGetTexParameteriv      = glGetTexParameteriv;
	qglHint                   = glHint;
	//qglIndexMask              = glIndexMask;
	//qglIndexPointer           = glIndexPointer;
	//qglIndexd                 = glIndexd;
	//qglIndexdv                = glIndexdv;
	//qglIndexf                 = glIndexf;
	//qglIndexfv                = glIndexfv;
	//qglIndexi                 = glIndexi;
	//qglIndexiv                = glIndexiv;
	//qglIndexs                 = glIndexs;
	//qglIndexsv                = glIndexsv;
	//qglIndexub                = glIndexub;
	//qglIndexubv               = glIndexubv;
	//qglInitNames              = glInitNames;
	//qglInterleavedArrays      = glInterleavedArrays;
	//qglIsEnabled              = glIsEnabled;
	//qglIsList                 = glIsList;
	//qglIsTexture              = glIsTexture;
	//qglLightModelf            = glLightModelf;
	//qglLightModelfv           = glLightModelfv;
	//qglLightModeli            = glLightModeli;
	//qglLightModeliv           = glLightModeliv;
	//qglLightf                 = glLightf;
	//qglLightfv                = glLightfv;
	//qglLighti                 = glLighti;
	//qglLightiv                = glLightiv;
	//qglLineStipple            = glLineStipple;
	//qglLineWidth              = glLineWidth;
	//qglListBase               = glListBase;
	qglLoadIdentity           = glLoadIdentity;
	qglLoadMatrixd            = glLoadMatrixd;
	qglLoadMatrixf            = glLoadMatrixf;
	//qglLoadName               = glLoadName;
	//qglLogicOp                = glLogicOp;
	//qglMap1d                  = glMap1d;
	//qglMap1f                  = glMap1f;
	//qglMap2d                  = glMap2d;
	//qglMap2f                  = glMap2f;
	//qglMapGrid1d              = glMapGrid1d;
	//qglMapGrid1f              = glMapGrid1f;
	//qglMapGrid2d              = glMapGrid2d;
	//qglMapGrid2f              = glMapGrid2f;
	//qglMaterialf              = glMaterialf;
	//qglMaterialfv             = glMaterialfv;
	//qglMateriali              = glMateriali;
	//qglMaterialiv             = glMaterialiv;
	qglMatrixMode             = glMatrixMode;
	qglMultMatrixd            = glMultMatrixd;
	qglMultMatrixf            = glMultMatrixf;
	qglNewList                = glNewList;
	qglNormal3b               = glNormal3b;
	qglNormal3bv              = glNormal3bv;
	qglNormal3d               = glNormal3d;
	qglNormal3dv              = glNormal3dv;
	qglNormal3f               = glNormal3f;
	qglNormal3fv              = glNormal3fv;
	qglNormal3i               = glNormal3i;
	qglNormal3iv              = glNormal3iv;
	qglNormal3s               = glNormal3s;
	qglNormal3sv              = glNormal3sv;
	qglNormalPointer          = glNormalPointer;
	qglOrtho                  = glOrtho;
	//qglPassThrough            = glPassThrough;
	//qglPixelMapfv             = glPixelMapfv;
	//qglPixelMapuiv            = glPixelMapuiv;
	//qglPixelMapusv            = glPixelMapusv;
	qglPixelStoref            = glPixelStoref;
	qglPixelStorei            = glPixelStorei;
	//qglPixelTransferf         = glPixelTransferf;
	//qglPixelTransferi         = glPixelTransferi;
	//qglPixelZoom              = glPixelZoom;
	//qglPointSize              = glPointSize;
	qglPolygonMode            = glPolygonMode;
	qglPolygonOffset          = glPolygonOffset;
	//qglPolygonStipple         = glPolygonStipple;
	qglPopAttrib              = glPopAttrib;
	qglPopClientAttrib        = glPopClientAttrib;
	qglPopMatrix              = glPopMatrix;
	//qglPopName                = glPopName;
	//qglPrioritizeTextures     = glPrioritizeTextures;
	qglPushAttrib             = glPushAttrib;
	qglPushClientAttrib       = glPushClientAttrib;
	qglPushMatrix             = glPushMatrix;
	//qglPushName               = glPushName;
	//qglRasterPos2d            = glRasterPos2d;
	//qglRasterPos2dv           = glRasterPos2dv;
	//qglRasterPos2f            = glRasterPos2f;
	//qglRasterPos2fv           = glRasterPos2fv;
	//qglRasterPos2i            = glRasterPos2i;
	//qglRasterPos2iv           = glRasterPos2iv;
	//qglRasterPos2s            = glRasterPos2s;
	//qglRasterPos2sv           = glRasterPos2sv;
	//qglRasterPos3d            = glRasterPos3d;
	//qglRasterPos3dv           = glRasterPos3dv;
	//qglRasterPos3f            = glRasterPos3f;
	//qglRasterPos3fv           = glRasterPos3fv;
	//qglRasterPos3i            = glRasterPos3i;
	//qglRasterPos3iv           = glRasterPos3iv;
	//qglRasterPos3s            = glRasterPos3s;
	//qglRasterPos3sv           = glRasterPos3sv;
	//qglRasterPos4d            = glRasterPos4d;
	//qglRasterPos4dv           = glRasterPos4dv;
	//qglRasterPos4f            = glRasterPos4f;
	//qglRasterPos4fv           = glRasterPos4fv;
	//qglRasterPos4i            = glRasterPos4i;
	//qglRasterPos4iv           = glRasterPos4iv;
	//qglRasterPos4s            = glRasterPos4s;
	//qglRasterPos4sv           = glRasterPos4sv;
	//qglReadBuffer             = glReadBuffer;
	//qglReadPixels             = glReadPixels;
	//qglRectd                  = glRectd;
	//qglRectdv                 = glRectdv;
	//qglRectf                  = glRectf;
	//qglRectfv                 = glRectfv;
	//qglRecti                  = glRecti;
	//qglRectiv                 = glRectiv;
	//qglRects                  = glRects;
	//qglRectsv                 = glRectsv;
	//qglRenderMode             = glRenderMode;
	qglRotated                = glRotated;
	qglRotatef                = glRotatef;
	qglScaled                 = glScaled;
	qglScalef                 = glScalef;
	qglScissor                = glScissor;
	//qglSelectBuffer           = glSelectBuffer;
	qglShadeModel             = glShadeModel;
	qglStencilFunc            = glStencilFunc;
	qglStencilMask            = glStencilMask;
	qglStencilOp              = glStencilOp;
	qglTexCoord1d             = glTexCoord1d;
	qglTexCoord1dv            = glTexCoord1dv;
	qglTexCoord1f             = glTexCoord1f;
	qglTexCoord1fv            = glTexCoord1fv;
	qglTexCoord1i             = glTexCoord1i;
	qglTexCoord1iv            = glTexCoord1iv;
	qglTexCoord1s             = glTexCoord1s;
	qglTexCoord1sv            = glTexCoord1sv;
	qglTexCoord2d             = glTexCoord2d;
	qglTexCoord2dv            = glTexCoord2dv;
	qglTexCoord2f             = glTexCoord2f;
	qglTexCoord2fv            = glTexCoord2fv;
	qglTexCoord2i             = glTexCoord2i;
	qglTexCoord2iv            = glTexCoord2iv;
	qglTexCoord2s             = glTexCoord2s;
	qglTexCoord2sv            = glTexCoord2sv;
	qglTexCoord3d             = glTexCoord3d;
	qglTexCoord3dv            = glTexCoord3dv;
	qglTexCoord3f             = glTexCoord3f;
	qglTexCoord3fv            = glTexCoord3fv;
	qglTexCoord3i             = glTexCoord3i;
	qglTexCoord3iv            = glTexCoord3iv;
	qglTexCoord3s             = glTexCoord3s;
	qglTexCoord3sv            = glTexCoord3sv;
	qglTexCoord4d             = glTexCoord4d;
	qglTexCoord4dv            = glTexCoord4dv;
	qglTexCoord4f             = glTexCoord4f;
	qglTexCoord4fv            = glTexCoord4fv;
	qglTexCoord4i             = glTexCoord4i;
	qglTexCoord4iv            = glTexCoord4iv;
	qglTexCoord4s             = glTexCoord4s;
	qglTexCoord4sv            = glTexCoord4sv;
	qglTexCoordPointer        = glTexCoordPointer;
	qglTexEnvf                = glTexEnvf;
	qglTexEnvfv               = glTexEnvfv;
	qglTexEnvi                = glTexEnvi;
	//qglTexEnviv               = glTexEnviv;
	qglTexGend                = glTexGend;
	qglTexGendv               = glTexGendv;
	qglTexGenf                = glTexGenf;
	qglTexGenfv               = glTexGenfv;
	qglTexGeni                = glTexGeni;
	qglTexGeniv               = glTexGeniv;
	qglTexImage1D             = glTexImage1D;
	qglTexImage2D             = glTexImage2D;
	qglTexParameterf          = glTexParameterf;
	qglTexParameterfv         = glTexParameterfv;
	qglTexParameteri          = glTexParameteri;
	qglTexParameteriv         = glTexParameteriv;
	qglTexSubImage1D          = glTexSubImage1D;
	qglTexSubImage2D          = glTexSubImage2D;
	qglTranslated             = glTranslated;
	qglTranslatef             = glTranslatef;
	qglVertex2d               = glVertex2d;
	qglVertex2dv              = glVertex2dv;
	qglVertex2f               = glVertex2f;
	qglVertex2fv              = glVertex2fv;
	qglVertex2i               = glVertex2i;
	qglVertex2iv              = glVertex2iv;
	qglVertex2s               = glVertex2s;
	qglVertex2sv              = glVertex2sv;
	qglVertex3d               = glVertex3d;
	qglVertex3dv              = glVertex3dv;
	qglVertex3f               = glVertex3f;
	qglVertex3fv              = glVertex3fv;
	qglVertex3i               = glVertex3i;
	qglVertex3iv              = glVertex3iv;
	qglVertex3s               = glVertex3s;
	qglVertex3sv              = glVertex3sv;
	qglVertex4d               = glVertex4d;
	qglVertex4dv              = glVertex4dv;
	qglVertex4f               = glVertex4f;
	qglVertex4fv              = glVertex4fv;
	qglVertex4i               = glVertex4i;
	qglVertex4iv              = glVertex4iv;
	qglVertex4s               = glVertex4s;
	qglVertex4sv              = glVertex4sv;
	qglVertexPointer          = glVertexPointer;
	qglViewport               = glViewport;

	return true;
}

void GLimp_EnableLogging( qboolean enable )
{
}

void GLimp_LogNewFrame( void )
{
}

void *qwglGetProcAddress(const char *sym)
{
	if( strcmp(sym, "glMultiTexCoord2fARB") == 0 )
		return glMultiTexCoord2fARB;
	if( strcmp(sym, "glActiveTextureARB") == 0 )
		return glActiveTextureARB;
	if( strcmp(sym, "glClientActiveTextureARB") == 0 )
		return glClientActiveTextureARB;

	return NULL;
}